package org.jw.de.muc_harlaching;

import jssc.SerialPort;
import jssc.SerialPortException;

/**
 * Dieses Fenster wird angezeigt, wenn jemand geklingel hat.
 * 
 * @author Jan
 */
public class Knocking extends javax.swing.JFrame {

    private static boolean _isVisible = false;
    
    private final SerialPort _port;
    
    public Knocking(final SerialPort port) {
        _port = port;
        initComponents();
        setLocationRelativeTo(null);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lb = new javax.swing.JLabel();
        btClose = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Klingel!");
        setAlwaysOnTop(true);
        setUndecorated(true);
        setResizable(false);

        lb.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/jw/de/muc_harlaching/Bell.gif"))); // NOI18N
        lb.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 1, true));
        lb.setMaximumSize(new java.awt.Dimension(600, 600));
        lb.setMinimumSize(new java.awt.Dimension(600, 600));
        lb.setPreferredSize(new java.awt.Dimension(600, 600));
        lb.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                bellClicked(evt);
            }
        });
        getContentPane().add(lb, java.awt.BorderLayout.CENTER);

        btClose.setFont(new java.awt.Font("Segoe UI", 0, 14)); // NOI18N
        btClose.setText("Schließen");
        btClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btCloseActionPerformed(evt);
            }
        });
        getContentPane().add(btClose, java.awt.BorderLayout.PAGE_END);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void bellClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_bellClicked
        try {
            _port.writeBytes(Commands.DISABLE_CMD);
        } catch (SerialPortException ex) {
            // TODO: Hier irgendwas schlaues machen!
        }
        dispose();
        _isVisible = false;
    }//GEN-LAST:event_bellClicked

    private void btCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btCloseActionPerformed
        bellClicked(null);
    }//GEN-LAST:event_btCloseActionPerformed

    
    public static void popUp(final SerialPort port) {
        java.awt.EventQueue.invokeLater(() -> {
            if ( !_isVisible ) {
                _isVisible = true;
                new Knocking(port).setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btClose;
    private javax.swing.JLabel lb;
    // End of variables declaration//GEN-END:variables
}
